# all files / ol/geom/ point.js

97.78% Statements 44/45
87.5% Branches 7/8
100% Functions 9/9
97.78% Lines 44/45

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    1291×

    1×
    1×
    1×
    1×
    1×
    1×

    1×
    520×
    520×

    1×

    1×
    30×
    30×
    30×

    1×

    1×
    1×

    1×
    1×
    1×
    1×
    4×

    1×
    1×

    1×
    163×

    1×
    267×

    1×
    125×

    1×
    9×

    1×
    614×
    148×

    466×
    466×
    372×

    466×

    466×

    1×
    294×
    294×

     goog.provide('ol.geom.Point');

    goog.require('ol.extent');
    goog.require('ol.geom.GeometryLayout');
    goog.require('ol.geom.GeometryType');
    goog.require('ol.geom.SimpleGeometry');
    goog.require('ol.geom.flat.deflate');
    goog.require('ol.math');

    /**
     * @classdesc
     * Point geometry.
     *
     * @constructor
     * @extends {ol.geom.SimpleGeometry}
     * @param {ol.Coordinate} coordinates Coordinates.
     * @param {ol.geom.GeometryLayout=} opt_layout Layout.
     * @api stable
     */
    ol.geom.Point = function(coordinates, opt_layout) {
      goog.base(this);
      this.setCoordinates(coordinates, opt_layout);
    };
    goog.inherits(ol.geom.Point, ol.geom.SimpleGeometry);

    /**
     * Make a complete copy of the geometry.
     * @return {!ol.geom.Point} Clone.
     * @api stable
     */
    ol.geom.Point.prototype.clone = function() {
      var point = new ol.geom.Point(null);
      point.setFlatCoordinates(this.layout, this.flatCoordinates.slice());
      return point;
    };

    /**
     * @inheritDoc
     */
    ol.geom.Point.prototype.closestPointXY =
        function(x, y, closestPoint, minSquaredDistance) {
      var flatCoordinates = this.flatCoordinates;
      var squaredDistance = ol.math.squaredDistance(
          x, y, flatCoordinates[0], flatCoordinates[1]);
      Eif (squaredDistance < minSquaredDistance) {
        var stride = this.stride;
        var i;
        for (i = 0; i < stride; ++i) {
          closestPoint[i] = flatCoordinates[i];
        }
        closestPoint.length = stride;
        return squaredDistance;
      } else {
        return minSquaredDistance;
      }
    };

    /**
     * Return the coordinate of the point.
     * @return {ol.Coordinate} Coordinates.
     * @api stable
     */
    ol.geom.Point.prototype.getCoordinates = function() {
      return !this.flatCoordinates ? [] : this.flatCoordinates.slice();
    };

    /**
     * @inheritDoc
     */
    ol.geom.Point.prototype.computeExtent = function(extent) {
      return ol.extent.createOrUpdateFromCoordinate(this.flatCoordinates, extent);
    };

    /**
     * @inheritDoc
     * @api stable
     */
    ol.geom.Point.prototype.getType = function() {
      return ol.geom.GeometryType.POINT;
    };

    /**
     * @inheritDoc
     * @api stable
     */
    ol.geom.Point.prototype.intersectsExtent = function(extent) {
      return ol.extent.containsXY(extent,
          this.flatCoordinates[0], this.flatCoordinates[1]);
    };

    /**
     * Set the coordinate of the point.
     * @param {ol.Coordinate} coordinates Coordinates.
     * @param {ol.geom.GeometryLayout=} opt_layout Layout.
     * @api stable
     */
    ol.geom.Point.prototype.setCoordinates = function(coordinates, opt_layout) {
      if (!coordinates) {
        this.setFlatCoordinates(ol.geom.GeometryLayout.XY, null);
      } else {
        this.setLayout(opt_layout, coordinates, 0);
        if (!this.flatCoordinates) {
          this.flatCoordinates = [];
        }
        this.flatCoordinates.length = ol.geom.flat.deflate.coordinate(
            this.flatCoordinates, 0, coordinates, this.stride);
        this.changed();
      }
    };

    /**
     * @param {ol.geom.GeometryLayout} layout Layout.
     * @param {Array.<number>} flatCoordinates Flat coordinates.
     */
    ol.geom.Point.prototype.setFlatCoordinates = function(layout, flatCoordinates) {
      this.setFlatCoordinatesInternal(layout, flatCoordinates);
      this.changed();
    };